package ch.hslu.appe.webservice.consumer;

import java.util.List;

import ch.hslu.appe.inventory.webservice.InventoryService;
import ch.hslu.appe.inventory.webservice.InventoryServiceImplService;
import ch.hslu.appe.inventory.webservice.ProductDto;

/**
 * InventoryConsumerImpl.
 */
public final class InventoryConsumerImpl implements InventoryConsumer {
    private InventoryService inventoryService;
    private static InventoryConsumerImpl instance;

    /**
     * Private constructor.
     */
    private InventoryConsumerImpl() {
        inventoryService = (new InventoryServiceImplService()).getInventoryServiceImplPort();
    }

    /**
     * getInstance.
     * @return instance
     */
    public static InventoryConsumer getInstance() {

        if (instance == null) {
            instance = new InventoryConsumerImpl();
        }

        return instance;
    }

    @Override
    public ProductDto getProduct(final int productNumber) {
        return inventoryService.getProduct(productNumber);
    }

    @Override
    public List<ProductDto> getProducts() {
        return inventoryService.getProducts();
    }

    @Override
    public boolean productActive(final int productNumber) {
        return inventoryService.productActive(productNumber);
    }

    @Override
    public boolean productExists(final int productNumber) {
        return inventoryService.productExists(productNumber);
    }

    @Override
    public List<ProductDto> getActiveProducts() {
        return inventoryService.getActiveProducts();
    }

}
